VERSION 5.00
Begin VB.UserControl ucThumb 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00000000&
   ClientHeight    =   1110
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4440
   ScaleHeight     =   74
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   296
   Begin VB.PictureBox picContainer 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      Height          =   735
      Left            =   240
      ScaleHeight     =   49
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   209
      TabIndex        =   0
      Top             =   120
      Width           =   3135
      Begin VB.PictureBox picScrolls 
         AutoRedraw      =   -1  'True
         BackColor       =   &H00FFFFFF&
         BorderStyle     =   0  'None
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Index           =   1
         Left            =   2520
         ScaleHeight     =   25
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   25
         TabIndex        =   3
         Tag             =   "1"
         Top             =   120
         Width           =   375
      End
      Begin VB.PictureBox picScrolls 
         AutoRedraw      =   -1  'True
         BackColor       =   &H00FFFFFF&
         BorderStyle     =   0  'None
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Index           =   0
         Left            =   120
         ScaleHeight     =   25
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   65
         TabIndex        =   2
         Tag             =   "0"
         Top             =   120
         Width           =   975
      End
      Begin VB.PictureBox picThumb 
         AutoRedraw      =   -1  'True
         BackColor       =   &H00000000&
         BorderStyle     =   0  'None
         Height          =   495
         Left            =   720
         ScaleHeight     =   33
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   65
         TabIndex        =   1
         Top             =   120
         Width           =   975
      End
   End
End
Attribute VB_Name = "ucThumb"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'///////////////////////////////////////////////////////////////////////////////////////////////////
'===================================================================================================

' >> Descripcin : Control para visualizar thumbnails en una barra con scroll
' >> Autor       : Luciano Lodola - http://www.recursosvisualbasic.com.ar/

'------------------------------------------------------------------------------

'
' >> Crditos    : A Gonchuki por la funcin base del procedimiento UpdateBtn
'                : A Leandro Ascierto por la funcin DrawSkinControl
'                : A Paul Caton por la clase cTimer

'===================================================================================================
'///////////////////////////////////////////////////////////////////////////////////////////////////
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================
'===================================================================================================



'----------------------------------------------------------------------------------------------------
'===============================================================================================================
' \\ - Constantes
'===============================================================================================================
'----------------------------------------------------------------------------------------------------


' Constantes para usar con la funcin Api DrawText
Private Const DT_LEFT As Long = &H0
Private Const DT_CALCRECT = &H400
Private Const DT_WORDBREAK = &H10
Private Const DT_CENTER = &H1 Or DT_WORDBREAK Or &H4

' Valores de constantes para los skins. Si se cambia las dimensiones del grfico, se deben cambiar las dimensiones de estas constantes
Private Const SkinBtnBorderW = 5
Private Const SkinBtnBorderH = 5
Private Const SkinBtnWidth = 15                         ' Ancho del skin
Private Const SkinBtnHeight = 23                        ' alto del Skin

Private Const RGN_COPY As Long = &H5&

' Cantidad de Skins a leer desde el archivo de recursos ( si se agregan mas al archivo .res , indicarlo en esta constante)
Private Const COUNT_SKIN_RES As Long = 21

' Colores por defecto
Private Const mDefForeColorNormal           As Long = &H80000012
Private Const mDefForeColorUp               As Long = vbBlue
Private Const mDefForeColorDown             As Long = &H80000012
Private Const mDefForeColorDisabled         As Long = &H80000012

Private Const SWP_NOMOVE = &H2
Private Const SWP_NOSIZE = &H1
  
'Constantes para SetWindowLong y GetWindowLong
Private Const GWL_EXSTYLE = (-20)
Private Const WS_EX_CLIENTEDGE = &H200
Private Const WS_EX_STATICEDGE = &H20000

Private Const LWA_ALPHA = &H2
Private Const WS_EX_LAYERED = &H80000



'----------------------------------------------------------------------------------------------------
'===============================================================================================================
' \\ - Fin de Constantes
'===============================================================================================================
'----------------------------------------------------------------------------------------------------


'----------------------------------------------------------------------------------------------------
''***************************************************************************************************
'----------------------------------------------------------------------------------------------------



'----------------------------------------------------------------------------------------------------
'===============================================================================================================
' \\ - Enumeraciones
'===============================================================================================================
'----------------------------------------------------------------------------------------------------

' Enumeracin para los Skins
Enum eSkin
    [VBNet] = 0
    [XPAmarillo] = 1
    [XPBlue] = 2
    [XP] = 3
    [XPRosa] = 4
    [Hotmail] = 5
    [WindowsMedia] = 6
    [WMPCobre] = 7
    [WMPVerde] = 8
    [Word2000] = 9
    [RoyaleXP] = 10
    [WindowsLive] = 11
    [WindowsLive2] = 12
    [GooglePicasa] = 13
    [Office2007BlueTabStrip] = 14
    [Office2007BlueButton] = 15
    [Office2007BlueCheckGreen] = 16
    [Hotmail2] = 17
    [WindowsVista] = 18
    [CBBlue] = 19
    [RoyaleXPWinTaskBar] = 20
    [Vista2] = 21
    [CustomSkin] = 22   ' skin personalizado
End Enum

' Tamao de los thumbnails ( Se pueden agregar mas o modificar, pero chequear la propiedad thumbnailSize )
Enum eThumbnailSize
    [24x24] = 24
    [32x32] = 32
    [40x40] = 40
    [48x48] = 48
    [64x64] = 64
    [96x96] = 96
    [128x128] = 128
    [156x156] = 156
    [200x200] = 200
    [256x256] = 256
End Enum

' Enum para pasar a las funcion que dubuja el skin para los Scrolls (el estado para los eventos del botn ( mouseup, down o Normal))
Enum eMouseEvent
    [eNormal] = 0
    [Up] = 1
    [down] = 2
End Enum

' Enum para la funcin GetSkinsColors ( Para poder recuperar en tiempo de ejecucin los colores de los skin y poder asociarlos a otros controles del programa: Color de fondo del formulario, bordes etc ..)
Enum ePosSkin
    [Normal_Skin] = 70
    [Border_Normal_Skin] = 60
    [Hot_Skin] = 12
    [Border_Hot_Skin] = 0
    [Border_Down_Skin] = 15
    [Down_Skin] = 27
    [Border_Hot_Check_Skin] = 30
    [Hot_Check_Skin] = 42
    [Border_Check_Skin] = 45
    [Check_Skin] = 57
End Enum

' Estado de los botones de Scroll
Enum ButtonState 'de uso interno(inventado)
    [TS_HOT] = 0
    [TS_PRESSED] = 1
    [TS_CHECKED] = 2    ' no se usa
    [TS_HOTCHECKED] = 3 ' no se usa
    [TS_NORMAL] = 4
    [TS_DISABLED] = 5
    [TS_DISABLED_CHECKED] = 6   ' no se usa
End Enum

' Estilo de borde de seleccin del Thumbnails ( Slido o rayado )
Enum eBorderStyleSel
    [eSolid] = 0
    [eDashDot] = 4
End Enum

' Tipo de scroll(Normal no usa el timer, eThumbs usa el timer para desplazar las imgenes, y tambin visualizar la imagen seleccionada en el centro del UC )
Enum eScrollMode
    [eThumbs] = 0
    [eNormalScroll] = 1
End Enum



'----------------------------------------------------------------------------------------------------
'===============================================================================================================
'\\ Fin de Enumraciones
'===============================================================================================================
'----------------------------------------------------------------------------------------------------



'----------------------------------------------------------------------------------------------------
''***************************************************************************************************
'----------------------------------------------------------------------------------------------------



'----------------------------------------------------------------------------------------------------
'===============================================================================================================
'\\ Types
'===============================================================================================================
'----------------------------------------------------------------------------------------------------

' para usos varios ( Api DrawText y otros )
Private Type RECT
    Left                                As Long
    Top                                 As Long
    Right                               As Long
    Bottom                              As Long
End Type

' Para usos varios ( Api getCursorPos, WindowFromPoint, otros ..)
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Type POINTAPI
    x                                   As Long
    Y                                   As Long
End Type

' Paleta de color del sistema ( api ChooseColor )
Private Type CHOOSECOLOR
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    rgbResult As Long
    lpCustColors As String
    flags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type



'----------------------------------------------------------------------------------------------------
''***************************************************************************************************
'----------------------------------------------------------------------------------------------------


'----------------------------------------------------------------------------------------------------
'===============================================================================================================
'\\ Fin de Types
'===============================================================================================================
'----------------------------------------------------------------------------------------------------




'----------------------------------------------------------------------------------------------------
'===============================================================================================================
'\\ Funciones Apis
'===============================================================================================================
'----------------------------------------------------------------------------------------------------

Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32.dll" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function SetStretchBltMode Lib "gdi32" (ByVal hdc As Long, ByVal nStretchMode As Long) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal Y As Long) As Long
Private Declare Function SetPixel Lib "gdi32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Private Declare Function CopyRect Lib "user32" (lpDestRect As RECT, lpSourceRect As RECT) As Long
Private Declare Function OffsetRect Lib "user32" (lpRect As RECT, ByVal x As Long, ByVal Y As Long) As Long
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long
Private Declare Function LockWindowUpdate Lib "user32" (ByVal hwndLock As Long) As Long
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetLayeredWindowAttributes Lib "user32" (ByVal hwnd As Long, ByVal crKey As Long, ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long
Private Declare Function CHOOSECOLOR Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As CHOOSECOLOR) As Long
'----------------------------------------------------------------------------------------------------
'===============================================================================================================
'\\ Fin de Apis
'===============================================================================================================
'----------------------------------------------------------------------------------------------------


'===================================================================================================
'///////////////////////////////////////////////////////////////////////////////////////////////////
'===================================================================================================

'----------------------------------------------------------------------------------------------------
'===============================================================================================================
' Variables
'===============================================================================================================
'----------------------------------------------------------------------------------------------------

Private hDCSkin                             As Long         ' HDC con el bitmap para el skin Actual
Private mLastButton                         As Integer      ' Almacena el ltimo botn presionado
Private mLastStat                           As Byte         ' Variable para almacenar el estado del botn ( Normal, presionado ) se usa solo para el evento pblico Refresh del UC

Private mEnabled                            As Boolean
Private mSkin                               As eSkin        ' Lista de skins
Private mToolTipText                        As String
Private mArrstdPicSkins()                   As StdPicture   ' Array para almacenar los skins que se cargan desde el .Res

' Colores ( BackColor y borde ) Para poder recuperar en tiempo de ejecucin los colores de los skin y poder asociarlos a otros controles del programa: Color de fondo del formulario, bordes etc ..) .. es opcional
Private mBackColorSkinDefault               As Long
Private mBorderColorSkinDefault             As Long

' Colores de fuente para los botones de Scroll
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private mForeColorNormal                    As OLE_COLOR
Private mForeColorUp                        As OLE_COLOR
Private mForeColorDown                      As OLE_COLOR
Private mForeColorDisabled                  As OLE_COLOR


' Flgs
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private mbFlagMouseOver                     As Boolean
Private mFlagReadInitProp                   As Boolean
Private mFinishLoadThumbs                   As Boolean
Public bFlagNoUpdateBtn                     As Boolean

Private mSkinCustomPicture                  As StdPicture
Private mHwndPicScroll                      As Long
Private mCurrentDirScroll                   As Integer
Private mSmallChangeScroll                  As Integer
Private mThumbnailSize                      As eThumbnailSize
Private mThumbnailMargin                    As Integer
Private mColThumbnails                      As Collection
Private mScrollWidth                        As Integer
Private mThumbnailContainerMargin           As Integer
Private mScrollMode                         As eScrollMode
Private mSelectedIndex                      As Integer
Private mBorderStyleSel                     As eBorderStyleSel
Private mIndexScrollOver                    As Integer
Private mBackColor                          As OLE_COLOR
Private mBorderColorSel                     As OLE_COLOR
Private mPosCenter                          As Long
Private mDirScrollSel                       As Integer
Private mOptionScroll                       As Integer
Private mValueScrollSel                     As Integer

' Para los dos timer ( el de los botones de scroll, y el de desplazamiento )
Private mTimer                              As cTimer
Implements WinSubHook2.iTimer

'----------------------------------------------------------------------------------------------------
'===============================================================================================================
'\\ Fin de variables
'===============================================================================================================
'----------------------------------------------------------------------------------------------------

'===================================================================================================
'///////////////////////////////////////////////////////////////////////////////////////////////////
'===================================================================================================

'----------------------------------------------------------------------------------------------------
'===============================================================================================================
'\\ Eventos
'===============================================================================================================
'----------------------------------------------------------------------------------------------------

' Eventos de los Thumbnails
Public Event ThumbnailClick(Index As Integer, pStdPicture As StdPicture)
Public Event ThumbnailMouseDown(Index As Integer, Button As Integer, Shift As Integer, x As Single, Y As Single)
Public Event ThumbnailMouseMove(Index As Integer, Button As Integer, Shift As Integer, x As Single, Y As Single)

' Progreso de carga de las imgenes
Public Event Progress(ByVal lValue As Integer, ByVal lMaxValue As Integer)
Public Event ProgressInit()
Public Event ProgressEnd()

Public Event Resize()

' Eventos de los botones de scroll
Public Event ScrollClick(ByVal Index As Integer)
Public Event ScrollMouseOver(ByVal Index As Integer)
Public Event ScrollMouseOut(ByVal Index As Integer)
Public Event ScrollMouseDown(ByVal Index As Integer, Button As Integer, Shift As Integer, x As Single, Y As Single)
Public Event ScrollMouseMove(ByVal Index As Integer, Button As Integer, Shift As Integer, x As Single, Y As Single)
Public Event ScrollMouseUp(ByVal Index As Integer, Button As Integer, Shift As Integer, x As Single, Y As Single)
Public Event StopScroll(Index As Integer)
Public Event Scroll(Index As Integer)

'Eventos de teclas
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyPress(KeyAscii As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)


' \\ -  Nota: !!!!!  Falta agregarlos
Public Event ThumbnailMouseUp(Index As Integer, Button As Integer, Shift As Integer, x As Single, Y As Single)


' \\ -  Nota: !!!!!  Falta agregarlos
Public Event ScrollKeyPress(ByVal Index As Integer, KeyAscii As Integer)
Public Event ScrollKeyDown(ByVal Index, KeyCode As Integer, Shift As Integer)
Public Event ScrollKeyUp(ByVal Index, KeyCode As Integer, Shift As Integer)


'----------------------------------------------------------------------------------------------------
'===============================================================================================================
' \\ Fin de eventos
'===============================================================================================================
'----------------------------------------------------------------------------------------------------

'===================================================================================================
'///////////////////////////////////////////////////////////////////////////////////////////////////
'===================================================================================================





'----------------------------------------------------------------------------------------------------
'===============================================================================================================
'\\ Mtodos y Funciones del control ( pblicos )
'===============================================================================================================
'----------------------------------------------------------------------------------------------------



' -------------------------------------------------------------------------------------------
' \\ - Para desplegar la paleta de widows para seleccionar color
' -------------------------------------------------------------------------------------------
Public Function ShowDialogColor(ByVal hwndOwner As Long, Optional lFlags As Long = 0) As Long

    Dim CustomColors() As Byte
    Dim cc As CHOOSECOLOR
    Dim Custcolor(16) As Long
    Dim lReturn As Long
    
    With cc
        .lStructSize = Len(cc)
        .hwndOwner = hwndOwner
        .hInstance = App.hInstance
        .lpCustColors = StrConv(CustomColors, vbUnicode)
        .flags = lFlags
    End With
    
    If CHOOSECOLOR(cc) <> 0 Then
        ShowDialogColor = cc.rgbResult
        CustomColors = StrConv(cc.lpCustColors, vbFromUnicode)
    Else
        ShowDialogColor = -1
    End If
End Function



'----------------------------------------------------------------------------------------------------
'\\ Dibujar Skin para el fondo ( Sobre el UC, o para usarlo desde el form y dibujar sobre un picBox  )
'----------------------------------------------------------------------------------------------------
Sub DrawSkinControl(Optional pObject As Object = Nothing, Optional ButtonState As ButtonState = TS_NORMAL)
        Dim dc As Long
        Dim hDCMemory As Long
        Dim hBmp As Long
        Dim SampleLeft As Long
        Dim lPixelWidth As Long
        Dim lPixelHeight As Long
        
        If Not pObject Is Nothing Then
            With pObject
                .Cls
                lPixelWidth = ScaleX(.ScaleWidth, .ScaleMode, vbPixels)
                lPixelHeight = ScaleY(.ScaleHeight, .ScaleMode, vbPixels)
            End With
        Else
            With UserControl
                .Cls
                lPixelWidth = ScaleX(.ScaleWidth, .ScaleMode, vbPixels)
                lPixelHeight = ScaleY(.ScaleHeight, .ScaleMode, vbPixels)
            End With
        End If
        
        dc = GetDC(0)
        hDCMemory = CreateCompatibleDC(0)
        hBmp = CreateCompatibleBitmap(dc, lPixelWidth, lPixelHeight)
        Call SelectObject(hDCMemory, hBmp)
        SetStretchBltMode hDCMemory, 4
        
        ' calcular la posicin X, del la imagen a dibujar
        ' A partir del pixel 0 hasta el 15 es el estado MouseOver -  Posicin 15 MouseDown. - Posicin 30 Ckeck - posicin 45 MouseOver para el Check - Posicin 60 Estado normal - Pixel 75 para el deshabilitado
        SampleLeft = (SkinBtnWidth * ButtonState)
        
        Call BitBlt(hDCMemory, 0, 0, SkinBtnBorderW, SkinBtnBorderH, hDCSkin, SampleLeft, 0, vbSrcCopy)
        Call BitBlt(hDCMemory, lPixelWidth - SkinBtnBorderW, 0, SkinBtnBorderW, SkinBtnBorderH, hDCSkin, SampleLeft + SkinBtnWidth - SkinBtnBorderW, 0, vbSrcCopy)
        Call StretchBlt(hDCMemory, SkinBtnBorderW, 0, lPixelWidth - SkinBtnBorderW * 2, SkinBtnBorderH, hDCSkin, SampleLeft + SkinBtnBorderW, 0, SkinBtnWidth - SkinBtnBorderW * 2, SkinBtnBorderH, vbSrcCopy)
        Call StretchBlt(hDCMemory, 0, SkinBtnBorderH, SkinBtnBorderW, lPixelHeight - SkinBtnBorderH * 2, hDCSkin, SampleLeft, SkinBtnBorderH, SkinBtnBorderW, SkinBtnHeight - SkinBtnBorderH * 2, vbSrcCopy)
        Call StretchBlt(hDCMemory, SkinBtnBorderW, SkinBtnBorderH, lPixelWidth - SkinBtnBorderW * 2, lPixelHeight - SkinBtnBorderH * 2, hDCSkin, SampleLeft + SkinBtnBorderW, SkinBtnBorderH, SkinBtnWidth - SkinBtnBorderW * 2, SkinBtnHeight - SkinBtnBorderH * 2, vbSrcCopy)
        Call StretchBlt(hDCMemory, lPixelWidth - SkinBtnBorderW, SkinBtnBorderH, SkinBtnBorderW, lPixelHeight - SkinBtnBorderH * 2, hDCSkin, SampleLeft + SkinBtnWidth - SkinBtnBorderW, SkinBtnBorderH, SkinBtnBorderW, SkinBtnHeight - SkinBtnBorderH * 2, vbSrcCopy)
        Call BitBlt(hDCMemory, 0, lPixelHeight - SkinBtnBorderH, SkinBtnBorderW, SkinBtnBorderH, hDCSkin, SampleLeft, SkinBtnHeight - SkinBtnBorderH, vbSrcCopy)
        Call StretchBlt(hDCMemory, SkinBtnBorderW, lPixelHeight - SkinBtnBorderH, lPixelWidth - SkinBtnBorderW * 2, SkinBtnBorderH, hDCSkin, SampleLeft + SkinBtnBorderW, SkinBtnHeight - SkinBtnBorderH, SkinBtnWidth - SkinBtnBorderW * 2, SkinBtnBorderH, vbSrcCopy)
        Call BitBlt(hDCMemory, lPixelWidth - SkinBtnBorderW, lPixelHeight - SkinBtnBorderH, SkinBtnBorderW, SkinBtnBorderH, hDCSkin, SampleLeft + SkinBtnWidth - SkinBtnBorderW, SkinBtnHeight - SkinBtnBorderH, vbSrcCopy)
        
        Dim lRet As Long
        If Not pObject Is Nothing Then
            lRet = BitBlt(pObject.hdc, 0, 0, lPixelWidth, lPixelHeight, hDCMemory, 0, 0, vbSrcCopy)
        Else
            lRet = BitBlt(UserControl.hdc, 0, 0, lPixelWidth, lPixelHeight, hDCMemory, 0, 0, vbSrcCopy)
        End If
        
        If lRet Then
            ' Eliminar los DC temporales
            Call DeleteDC(dc)
            Call DeleteDC(hDCMemory)
            Call DeleteObject(hBmp)
        Else
            MsgBox "Error en el procedimiento DrawSkin", vbCritical
        End If
End Sub


'----------------------------------------------------------------------------------------------------
'\\ Funcin para Seleccionar una imagen a partir del ndice
'----------------------------------------------------------------------------------------------------

Sub SelectedThumnail(Index As Integer, Optional RaiseEventClick As Boolean = True)
    Call mSelectedThumb(Index, RaiseEventClick)
End Sub


'----------------------------------------------------------------------------------------------------
'\\ Para mostrar los Thumbnails luego de cargarlos con 'AddThumbnails' o para refrescar desde algunas propiedades ( Thumbnailsize, BackColor, otros )
'----------------------------------------------------------------------------------------------------
Sub ShowThumbnails()
On Error GoTo error_handler

    Dim lRet As Long
    Dim i As Integer
    
    If Not Ambient.UserMode Then Exit Sub
    
    ' Propiedades del picBox que contiene los Thumbnails
    With picThumb
        .Visible = False
        ' Valor inicial para el ancho
        .Width = (mColThumbnails.Count * mThumbnailSize) + (mThumbnailSize + (mThumbnailMargin * 2))
        ' Eliminar cualquier imagen previa
        Set .Picture = Nothing
        .Cls
    End With
    
    DoEvents
    ' Lanzar evento para iniciar ( se puede usar para resetear una barra de progreso )
    RaiseEvent ProgressInit
    
    
    ' Comenzar a dibujar las imgenes
    ''----------------------------------------------------------------------------------------------------
    
    ' Recorrer la coleccin de imgenes
    For i = 1 To mColThumbnails.Count
        ' mColThumbnails(i) contiene la imagen, mScaleImage la dibuja en el picBox, i es la el Left
        lRet = mScaleImage(mColThumbnails(i), i)
        ' Enviar valor del progreso
        RaiseEvent Progress(i, CInt(mColThumbnails.Count))
    Next
    
    ' Fin
    ''----------------------------------------------------------------------------------------------------
    
    With picThumb
        ' Crear el picture para poder dibujar el rectngulo de seleccin, y mantener los thumbnails
        Set .Picture = .Image
        .Cls
        .Refresh
        .Visible = True
    End With
    
    ' .. si hay imgenes
    If mColThumbnails.Count > 0 Then
       ' Establecer como Thumbnail seleccionado , la ltima imagen
       If mSelectedIndex = -1 Then mSelectedIndex = mColThumbnails.Count
       ' Seleccionar ( Dibujar rectngulo de seleccin)
       Call mSelectedThumb(mSelectedIndex, False)
    End If
    
    picContainer.Visible = True
    mFinishLoadThumbs = False
    
    ' Enviar notificacin para finalizar el progreso
    DoEvents
    RaiseEvent ProgressEnd
    
    
'\\ Errores
'----------------------------------------------------------------------------------------------------
Exit Sub
error_handler:
    If App.LogMode = 0 Then
       MsgBox Err.Description, vbCritical, "Error: " & CStr(Err.Number)
    Else
       Err.Raise Err.Number, App.EXEName, Err.Description
    End If
End Sub


'----------------------------------------------------------------------------------------------------
'\\ Eliminar todos los Thumbnails
'----------------------------------------------------------------------------------------------------
Sub RemoveThumbnails()

On Error GoTo error_handler
    ' Recorrer toda la coleccin
    With mColThumbnails
        ' mientras haya, eliminar el primero hasta que no haya mas
        While .Count > 0
            .Remove 1
        Wend
    End With
    
    ' setear valores del picture Thumbnail ( el ancho y estableccer la imagen seleccionada )
    With picThumb
        .Width = 0
        .Left = mScrollWidth
        .Cls
        Set .Picture = Nothing
    End With

    mSelectedIndex = -1

'\\ Errores
'----------------------------------------------------------------------------------------------------
Exit Sub
error_handler:
    If App.LogMode = 0 Then
       MsgBox Err.Description, vbCritical, "Error: " & CStr(Err.Number)
    Else
       Err.Raise Err.Number, App.EXEName, Err.Description
    End If
End Sub


'----------------------------------------------------------------------------------------------------
'\\ Eliminar un Thumbnail
'----------------------------------------------------------------------------------------------------
Sub RemoveThumb(IndexOrKey As Variant)
    On Error GoTo error_handler
     
     
    With mColThumbnails
        ' Comprobar si hay imgenes
        If .Count > 0 Then
            ' Eliminar pasando el ndice o la clave
            Call .Remove(IndexOrKey)
            
            ' Establecer como imagen seleccionada la nmero 1
            If .Count > 0 Then
               mSelectedIndex = 1
            Else
               ' si no hay imgenes , setear el seleccionado en ninguno
               mSelectedIndex = 0
               Call RemoveThumbnails
            End If
            
            ' volver a dibujar los grficos
            Call ShowThumbnails
        End If
    End With
    
'\\ Errores
'----------------------------------------------------------------------------------------------------
Exit Sub
error_handler:
    If App.LogMode = 0 Then
        ' Error cuando se intenta eliminar un item de la coleccin con un ndice o clave inexistente
        If Err.Number <> 5 Then
            MsgBox Err.Description, vbCritical
        Else
            MsgBox "No se ha encontrado el elemento indicado en la coleccin", vbCritical
        End If
    Else
        If Err.Number = 5 Then
            Err.Raise 5, App.EXEName, "No se ha encontrado el elemento indicado en la coleccin"
        Else
            Err.Raise Err.Number, App.EXEName, Err.Description
        End If
    End If
End Sub



'----------------------------------------------------------------------------------------------------
'\\ Funcin para Ocultar y mostrar los Thumbnails
' ---------------------------------------------------------------------------------------------------

Sub HideThumbnails()
    picThumb.Visible = False
End Sub



'----------------------------------------------------------------------------------------------------
'\\ Funcin para modificar una imagen ya cargada en la coleccin
' ---------------------------------------------------------------------------------------------------

Sub ChangeThumb(NewStdPicThumbnail As StdPicture, Index As Long, Optional NewKey As String = vbNullString)
    
On Error GoTo error_handler
    
    With mColThumbnails
    
        ' verificar que el ndice sea vlido
        If Index > .Count Or Index < 1 Then
           If App.LogMode = 0 Then
              MsgBox "El subindice est fuera del intervalo"
           Else
              Err.Raise 5, App.EXEName, "El subindice est fuera del intervalo"
           End If
           Exit Sub
        ElseIf IsNumeric(NewKey) Then
           If App.LogMode = 0 Then
              MsgBox "Una clave numrica no es vlida"
           Else
              Err.Raise 35603, App.EXEName, "Una clave numrica no es vlida"
           End If
           Exit Sub
           
        ' Ok > Cambiar
        Else
            ' si el indice es menor agregarlo antes
            
            If Index < .Count Then
                ' Remover el item y agregar el nuevo
                .Remove Index
                .Add NewStdPicThumbnail, NewKey, Index
            ' .. si es el ltimo o es el nico ( es decir 1 solo ), eliminarlo y agregarlo normalmente
            ElseIf Index = .Count Then
                .Remove Index
                .Add NewStdPicThumbnail, NewKey
            End If
        End If
    End With
    
    Me.ShowThumbnails

Exit Sub

'\\ Error
' ---------------------------------------------------------------------------------------------------
error_handler:
    Err.Raise Err.Number, App.EXEName, Err.Description
End Sub


'----------------------------------------------------------------------------------------------------
'\\ Retorna la coleccin
' ---------------------------------------------------------------------------------------------------

Function GetThumbnailColection() As Collection
    Set GetThumbnailColection = mColThumbnails
End Function

'----------------------------------------------------------------------------------------------------
'\\ Funcin para agregar los Thumbnails ( stdPic es la imagen, sKey valor opcional para la clave de la imagen )
' ---------------------------------------------------------------------------------------------------

Sub AddThumb(stdPic As IPictureDisp, Optional sKey As String)
     
    On Error GoTo error_handler
                
    ' Verificar que la clave no sea numrica, si no salir
    If IsNumeric(sKey) Then
        If App.LogMode = 0 Then
           MsgBox "Una clave numrica no es vlida"
        Else
           Err.Raise 35603, App.EXEName, "Una clave numrica no es vlida"
        End If
        Exit Sub ' ---> salir
    End If

    
    With picThumb
        ' Si est visible el picBox de los Thumbnails, ocultarlo hasta que se termine de cargar todos los grficos
        If .Visible Then .Visible = False
        
        ' Comprobar el Ancho del picBox del Thumbnail:
        ' (16383 es el ancho mximo  de un picbox, un valor superior ya no sigue aumentando de tamao, ... entonces salir)
        If (mColThumbnails.Count > 0) And _
           (mColThumbnails.Count * mThumbnailSize) >= (16383 - mThumbnailSize) Then
           mFinishLoadThumbs = True
           Exit Sub
        End If
    End With
    
    ' Agregar la imagen a la coleccin
    Call mColThumbnails.Add(stdPic, sKey)
    
    Set stdPic = Nothing
    
    ' Setear el Thumbnil actual a ninguno .. por las dudas
    mSelectedIndex = -1


'\\ Errores
' '----------------------------------------------------------------------------------------------------
Exit Sub
error_handler:

    If App.LogMode = 0 Then
       ' Error por si se intenta aadir un valor a la coleccin 'con la misma clave'
       If Err.Number = 457 Then
          MsgBox "Ya se ha agregado esta imagen", vbCritical, "Error: " & CStr(Err.Number)
       Else
          MsgBox Err.Description, vbCritical
       End If
    Else
       If Err.Number = 457 Then
          Err.Raise 457, "AddThumb", "Ya se ha agregado esta imagen"
       Else
          Err.Raise Err.Number, "AddThumb", Err.Description
       End If
    End If

End Sub


'----------------------------------------------------------------------------------------------------
'\\ Funcin opcional para poder recuperar en tiempo de ejecucin los colores de los skin y poder asociarlos a otros controles del programa: Color de fondo del formulario, bordes etc ..)
'----------------------------------------------------------------------------------------------------

Function GetSkinsColors(lImgStateButton As ePosSkin) As Long
    Dim Y As Long
    Dim x As Long
        
    ' setear posicin 'y' de la imagen donde se obtendr el pixel
    If (lImgStateButton = Border_Check_Skin) Or _
       (lImgStateButton = Border_Normal_Skin) Or _
       (lImgStateButton = Border_Down_Skin) Or _
       (lImgStateButton = Border_Hot_Check_Skin) Or _
       (lImgStateButton = Border_Hot_Skin) Then
       Y = 22
    Else
       Y = 5
    End If
    
    x = lImgStateButton
    
    ' obtener desde el DC que tiene la imagen ... el color del pixel y retornar el valor a la funcin
    GetSkinsColors = GetPixel(hDCSkin, x, Y)
End Function



'----------------------------------------------------------------------------------------------------
' \\ Refrescar UC ( los botones de Scroll y todas las imgenes cargadas en la coleccin )
'----------------------------------------------------------------------------------------------------

Sub Refresh()
    Call mUpdateBtn(mLastStat, picScrolls(0))
    Call mUpdateBtn(mLastStat, picScrolls(1))
    Call ShowThumbnails
End Sub

'----------------------------------------------------------------------------------------------------
'\\ Funcin para Establecer transparencia a una ventana ( No se usa )
'----------------------------------------------------------------------------------------------------

Public Function SetTrans(ByVal lHwnd As Long, lValue As Byte) As Long
    
    Dim lStyle As Long
    lStyle = GetWindowLong(lHwnd, GWL_EXSTYLE)
    lStyle = lStyle Or WS_EX_LAYERED
      
    Call SetWindowLong(lHwnd, GWL_EXSTYLE, lStyle)
    SetTrans = SetLayeredWindowAttributes(lHwnd, 0, lValue, LWA_ALPHA)

End Function



'----------------------------------------------------------------------------------------------------
'===============================================================================================================
' Fin de Subs y funciones pblicas
'===============================================================================================================
'----------------------------------------------------------------------------------------------------


'----------------------------------------------------------------------------------------------------
'===============================================================================================================
' Subs, Funciones privadas
'===============================================================================================================
'----------------------------------------------------------------------------------------------------



'----------------------------------------------------------------------------------------------------
'\\ 2 Timers - Id 0 es para el los botones de Scroll, el Timer ID1 es para el Scroll
'----------------------------------------------------------------------------------------------------
Private Sub iTimer_Proc(ByVal lElapsedMS As Long, ByVal lTimerID As Long)
    
    '----------------------------------------------------------------------------------------------------
    ' Timer 1
    '----------------------------------------------------------------------------------------------------
    If lTimerID = 0 Then
        ' si se produce el MouseOut .....
        If Not mIsMouseOver Then
            ' Lanzar evento, Terminar el timer y redibujar
            RaiseEvent ScrollMouseOut(mIndexScrollOver)
            mTimer.TmrStop
            mbFlagMouseOver = False
            Call mUpdateBtn(eNormal, picScrolls(0))
            Call mUpdateBtn(eNormal, picScrolls(1))
        End If
    
    '----------------------------------------------------------------------------------------------------
    ' Timer 2
    '----------------------------------------------------------------------------------------------------
    ElseIf lTimerID = 1 Then
        
        Select Case mOptionScroll
        
            ' Cuando ScrollMode est en Normal
            '----------------------------------------------------------------------------------------------------
            
            Case 0
                With picThumb
                    Select Case mCurrentDirScroll
                        Case 0
                            If .Left < picScrolls(0).Width Then
                                .Left = .Left + mSmallChangeScroll
                                RaiseEvent Scroll(0)
                            Else
                                mTimer.TmrStop
                                .Left = mScrollWidth
                                RaiseEvent StopScroll(0)
                            End If
                        Case 1
                            If (.Left) > (-.Width) + (picContainer.ScaleWidth) Then
                                .Left = .Left - mSmallChangeScroll
                                RaiseEvent Scroll(1)
                            Else
                                mTimer.TmrStop
                                If (.Width - (mScrollWidth * 2)) > picContainer.ScaleWidth Then
                                    .Left = (-.Width) + (picContainer.ScaleWidth)
                                End If
                                RaiseEvent StopScroll(1)
                            End If
                    End Select
                End With
                
            ' Cuando ScrollMode est en eThumb
            '----------------------------------------------------------------------------------------------------
            Case 1
                With picThumb
                    Select Case mDirScrollSel
                        Case 0
                            If (.Left) < (mPosCenter - ((mSelectedIndex - 1) * mThumbnailSize)) Then
                                .Left = .Left + mValueScrollSel
                            Else
                                Call mFinishScroll
                            End If
                        Case 1
                            If .Left > mPosCenter - ((mSelectedIndex - 1) * mThumbnailSize) Then
                               .Left = .Left - mValueScrollSel
                            Else
                                Call mFinishScroll
                            End If
                    End Select
                End With
        End Select
    End If
End Sub



'----------------------------------------------------------------------------------------------------
'\\ Funcin para escalar y dibujar los Thumbnails
'----------------------------------------------------------------------------------------------------

Private Function mScaleImage(pStdPic As StdPicture, lIndexImage As Integer) As Boolean

On Error GoTo error_handler
    
    
    Dim HScale As Double
    Dim VScale As Double
    Dim MyScale As Double
    Dim ImgWidth As Long
    Dim ImgHeight As Long
    Dim SourceHDC As Long
    
    With picThumb
        ' Ancho y alto de la imagen
        ImgWidth = .ScaleX(pStdPic.Width, vbHimetric, vbPixels)
        ImgHeight = .ScaleY(pStdPic.Height, vbHimetric, vbPixels)
        ' porcentaje de escala
        HScale = (mThumbnailSize / ImgWidth)
        VScale = (mThumbnailSize / ImgHeight)
    End With
    
    MyScale = IIf(VScale >= HScale, HScale, VScale)
    
    Dim r As RECT
    ' Dimensiones y posicin del Thumbnail para dibujar con StretchBlt
    With r
        .Right = (ImgWidth * MyScale) - mThumbnailMargin
        .Bottom = (ImgHeight * MyScale) - mThumbnailMargin
        .Left = (((mThumbnailSize - .Right)) / 2) + ((lIndexImage - 1) * mThumbnailSize) + (mThumbnailMargin / 2)
        .Top = ((mThumbnailSize - .Bottom)) / 2
    End With
          
    ' Crear el un DC para el Thumbnail
    SourceHDC = CreateCompatibleDC(0)
    
    ' Mandar la imagen al DC
    DeleteObject SelectObject(SourceHDC, pStdPic.Handle)
    
    Call SetStretchBltMode(picThumb.hdc, vbPaletteModeNone)
    
    Dim lRet As Long
    ' Dibujarlo en el picox
    lRet = StretchBlt(picThumb.hdc, r.Left, r.Top, r.Right, r.Bottom, SourceHDC, 0, 0, ImgWidth, ImgHeight, vbSrcCopy)
    
    ' Eliminar el DC
    Call DeleteDC(SourceHDC)
    
    ' Retornar
    If lRet Then mScaleImage = True
    
    
' \\ Errores
'----------------------------------------------------------------------------------------------------

    Exit Function
error_handler:
    If App.LogMode = 0 Then
       MsgBox Err.Description, vbCritical, "Error: " & CStr(Err.Number)
    Else
       Err.Raise Err.Number, App.EXEName, Err.Description
    End If
End Function


'----------------------------------------------------------------------------------------------------
' \\ Funcin para asignar los colores de fuente de los botones cuando tienen Skin y mColorSchemas es igual a UseSkin
'----------------------------------------------------------------------------------------------------
Private Sub mSetColorSchemas()
    
    ' Salir de la rutina si se est leyendo y cargando las propiedades desde el Propbag
    If mFlagReadInitProp Then Exit Sub
        
        ' 0 -  VBNet
        ''''''''''''''''''''''''''''''''''
        If (mSkin = VBNet) Then
            mForeColorDown = vbBlack
            mForeColorNormal = vbBlack
            mForeColorUp = vbBlack
            mForeColorDisabled = RGB(144, 144, 144)
            mBorderColorSkinDefault = RGB(212, 230, 253)
            mBackColorSkinDefault = RGB(237, 244, 254)
            Exit Sub
        End If
        
        ' 1 - XP amarillo
        ' '''''''''''''''''''''''''''''''''
        
        If (mSkin = XPAmarillo) Then
            mForeColorDown = mFlagReadInitProp
            mForeColorNormal = vbBlack
            mForeColorUp = vbBlack
            mForeColorDisabled = RGB(147, 157, 17)
            mBorderColorSkinDefault = RGB(239, 242, 159)
            mBackColorSkinDefault = RGB(251, 252, 227)
            Exit Sub
        End If
        
        ' 2 - Xp Azul
        ' ''''''''''''''''''''''''''''''''''''
        
        If (mSkin = XPBlue) Then
            mForeColorDown = mFlagReadInitProp
            mForeColorNormal = vbBlack
            mForeColorUp = vbBlack
            mForeColorDisabled = RGB(190, 190, 190)
            mBorderColorSkinDefault = RGB(232, 236, 255)
            mBackColorSkinDefault = RGB(253, 253, 255)
            Exit Sub
        End If
        
        ' 3 - XP
        ' '''''''''''''''''''''''''''''''''''''
        
        If (mSkin = XP) Then
            mForeColorDown = vbBlack
            mForeColorNormal = vbBlack
            mForeColorUp = vbBlack
            mForeColorDisabled = RGB(190, 190, 190)
            mBackColorSkinDefault = RGB(251, 251, 248)
            mBorderColorSkinDefault = RGB(230, 230, 223)
            Exit Sub
        End If
        
        
        ' 4 - XP Rosa
        ' '''''''''''''''''''''''''''''''''''''''
        If (mSkin = XPRosa) Then
            mForeColorDown = mFlagReadInitProp
            mForeColorNormal = vbBlack
            mForeColorUp = vbBlack
            mForeColorDisabled = RGB(255, 166, 255)
            mBackColorSkinDefault = RGB(255, 242, 255)
            mBorderColorSkinDefault = RGB(255, 213, 255)
            Exit Sub
        End If
        
        
        ' 5 - Hotmail
        ' '''''''''''''''''''''''''''''''''''''''
        
        If (mSkin = Hotmail) Then
            mForeColorDown = vbWhite
            mForeColorNormal = vbWhite
            mForeColorUp = vbWhite
            mForeColorDisabled = 0
            mBackColorSkinDefault = RGB(0, 75, 121)
            mBorderColorSkinDefault = RGB(98, 158, 199)
            
            Exit Sub
        End If
        
        
        
        ' 6 - windows Media
        ' ''''''''''''''''''''''''''''''''''''''''
        
        If (mSkin = WindowsMedia) Then
            mForeColorDown = vbWhite
            mForeColorNormal = vbWhite
            mForeColorUp = vbWhite
            mForeColorDisabled = RGB(190, 190, 190)
            mBackColorSkinDefault = RGB(58, 64, 78)
            mBorderColorSkinDefault = RGB(96, 106, 133)
            
            Exit Sub
        End If
        
        ' 7 - WMPCobre
        ' ''''''''''''''''''''''''''''''''''''''''
        
        If (mSkin = WMPCobre) Then
            mForeColorDown = vbWhite
            mForeColorNormal = vbWhite
            mForeColorUp = vbWhite
            mForeColorDisabled = RGB(170, 170, 170)
            mBackColorSkinDefault = 0
            mBorderColorSkinDefault = RGB(112, 65, 39)
            
            Exit Sub
        End If
                
        
        ' 8 - Wmp Verde
        ' '''''''''''''''''''''''''''''''''''''''''''''
        
         
        If (mSkin = WMPVerde) Then
            mForeColorDown = vbWhite
            mForeColorNormal = vbWhite
            mForeColorUp = vbWhite
            mForeColorDisabled = RGB(170, 170, 170)
            mBackColorSkinDefault = 0
            mBorderColorSkinDefault = RGB(0, 98, 0)
            Exit Sub
        End If
        
        
        '  9 - Word
        ' '''''''''''''''''''''''''''''''''''''''''''''''
        
        If (mSkin = Word2000) Then
            mForeColorDown = vbBlack
            mForeColorNormal = vbBlack
            mForeColorUp = vbBlack
            mForeColorDisabled = RGB(190, 190, 190)
            mBackColorSkinDefault = RGB(248, 247, 243)
            mBorderColorSkinDefault = RGB(227, 223, 212)
            Exit Sub
        End If
        
        
        ' 10 - Royale XP
        ' '''''''''''''''''''''''''''''''''''''''''''''''
        
        If (mSkin = RoyaleXP) Then
            mForeColorDown = vbBlack
            mForeColorNormal = vbBlack
            mForeColorUp = vbBlack
            mForeColorDisabled = RGB(190, 190, 190)
            mBackColorSkinDefault = RGB(251, 252, 255)
            mBorderColorSkinDefault = RGB(214, 213, 217)
            
            Exit Sub
        End If
        
        
        ' 11 -  Windows Live
        ' '''''''''''''''''''''''''''''''''''''''''''''''
        
        If (mSkin = WindowsLive) Then
            mForeColorDown = vbBlack
            mForeColorNormal = vbBlack
            mForeColorUp = vbBlack
            mForeColorDisabled = RGB(190, 190, 190)
            mBackColorSkinDefault = vbWhite
            mBorderColorSkinDefault = RGB(236, 236, 238)
            Exit Sub
        End If
        
        
        ' 12 -  Windows Live 2
        ' '''''''''''''''''''''''''''''''''''''''''''''''
        
        If (mSkin = WindowsLive2) Then
            mForeColorDown = vbBlack
            mForeColorNormal = vbBlack
            mForeColorUp = vbBlack
            mForeColorDisabled = RGB(190, 190, 190)
            mBackColorSkinDefault = RGB(243, 243, 243)
            mBorderColorSkinDefault = RGB(227, 227, 227)
            Exit Sub
        End If
    
        
                
        ' 13 - google Picasa
        ' '''''''''''''''''''''''''''''''''''''''''''''''''
        If (mSkin = GooglePicasa) Then
            mForeColorDown = vbBlack
            mForeColorNormal = vbBlack
            mForeColorUp = vbBlack
            mForeColorDisabled = RGB(180, 180, 180)
            mBackColorSkinDefault = RGB(233, 233, 233)
            mBorderColorSkinDefault = RGB(202, 202, 202)
            
            Exit Sub
        End If
        
        
        ' 14 - Office 2007 Blue Tab strip
        ' ''''''''''''''''''''''''''''''''''''''''''''''''''
        If (mSkin = Office2007BlueTabStrip) Then
           mForeColorDown = vbBlack
           mForeColorNormal = RGB(34, 66, 125)
           mForeColorUp = vbBlack
           mForeColorDisabled = RGB(101, 146, 214)
           mBackColorSkinDefault = RGB(240, 244, 255)
           mBorderColorSkinDefault = RGB(191, 209, 233)
           
           Exit Sub
        End If
        
        
        ' 15 - Office 2007 Blue botn
        ' ''''''''''''''''''''''''''''''''''''''''''''''''''
        If (mSkin = Office2007BlueButton) Then
           mForeColorDown = vbWhite
           mForeColorNormal = RGB(41, 90, 171)
           mForeColorUp = RGB(41, 90, 171)
           mForeColorDisabled = RGB(161, 161, 146)
           mBackColorSkinDefault = RGB(251, 252, 255)
           mBorderColorSkinDefault = RGB(213, 214, 218)
           Exit Sub
        End If
        
        
        
        
        ' 16 - Office 2007 Blue Check Green
        ' ''''''''''''''''''''''''''''''''''''''''''''''''''
        If (mSkin = Office2007BlueCheckGreen) Then
           mForeColorNormal = RGB(23, 51, 96)
           mForeColorDown = mForeColorNormal
           mForeColorUp = mForeColorNormal
           mForeColorDisabled = RGB(115, 155, 221)
           mBackColorSkinDefault = RGB(240, 244, 255)
           mBorderColorSkinDefault = RGB(191, 209, 233)
           
           Exit Sub
        End If
        
                
        ' 17 - Hotmail 2
        ' '''''''''''''''''''''''''''''''''''''''''''''''''''
        If (mSkin = Hotmail2) Then
            mForeColorDown = vbWhite
            mForeColorNormal = vbWhite
            mForeColorUp = vbWhite
            mForeColorDisabled = RGB(161, 161, 146)
            mBackColorSkinDefault = RGB(39, 75, 22)
            mBorderColorSkinDefault = RGB(66, 95, 50)
           
           Exit Sub
        End If
        
        
                
        ' 18 - windows Vista
        ' ''''''''''''''''''''''''''''''''''''''''''''''''''''
        
        If (mSkin = WindowsVista) Then
            mForeColorDown = vbBlack
            mForeColorNormal = RGB(48, 98, 139)
            mForeColorUp = vbBlack
            mForeColorDisabled = RGB(161, 161, 146)
            mBackColorSkinDefault = RGB(251, 251, 251)
            mBorderColorSkinDefault = RGB(215, 215, 215)
            
            Exit Sub
        End If
        
        
        ' 19 - CBBlue
        ' '''''''''''''''''''''''''''''''''''''''''''''''''''''
        
        If (mSkin = CBBlue) Then
           mForeColorDown = vbWhite
           mForeColorNormal = vbBlack
           mForeColorUp = vbWhite
           mForeColorDisabled = RGB(111, 153, 200)
           mBackColorSkinDefault = RGB(231, 238, 245)
           mBorderColorSkinDefault = RGB(210, 223, 238)
           
           Exit Sub
        End If
        
        ' 20
        ' '''''''''''''''''''''''''''''''''''''''''''''''''''''
        
        If (mSkin = RoyaleXPWinTaskBar) Then
           mForeColorDown = vbWhite
           mForeColorNormal = vbWhite
           mForeColorUp = vbWhite
           mForeColorDisabled = RGB(180, 180, 180)
           mBackColorSkinDefault = RGB(51, 103, 189)
           mBorderColorSkinDefault = RGB(210, 223, 238)
           Exit Sub
        End If
        
        ' 20
        ' '''''''''''''''''''''''''''''''''''''''''''''''''''''
        
        If (mSkin = Vista2) Then
           mForeColorNormal = RGB(5, 50, 89)
           mForeColorDown = mForeColorNormal
           mForeColorUp = mForeColorNormal
           mForeColorDisabled = RGB(213, 216, 225)
           mBackColorSkinDefault = RGB(241, 243, 248)
           mBorderColorSkinDefault = RGB(178, 182, 197)
           Exit Sub
        End If
End Sub

'----------------------------------------------------------------------------------------------------
'\\ -  hDCSkin -> HDC en memoria con la imagen del Skin ( se usa en la funcin DrawSkin para dibujar la imagen de los diferentes estados del botn  )
'----------------------------------------------------------------------------------------------------
Private Sub mSelectSkin(Optional ByVal lHandle As Long)
    If hDCSkin Then Call DeleteDC(hDCSkin) ' Eliminar el DC
    hDCSkin = CreateCompatibleDC(0)        ' Crearlo de nuevo
    Call SelectObject(hDCSkin, lHandle)    ' Establecer la imagen
End Sub


'----------------------------------------------------------------------------------------------------
'\\ -  Funcin  para verificar los estados del mouse sobre el botn, y  redibujar
'----------------------------------------------------------------------------------------------------
Private Sub mUpdateBtn(ByVal lMouseEvent As eMouseEvent, pPicScroll As PictureBox)
    
    ' Flag Para que no redibuje en la carga de propiedades ( se  setea el flag al finalizar el ReadProperty para actualizae todo)
    If mFlagReadInitProp Or bFlagNoUpdateBtn Then Exit Sub
            
    ' guardar ltimo estado, se usa para el refresh del UC y para el GotFocus
    mLastStat = lMouseEvent
    
    pPicScroll.Cls
        
    ' Botn Deshabilitado ::: Enabled = False
    '----------------------------------------------------------------------------------------------------
    Select Case mEnabled
       
       Case False
            Call mDrawSkinScroll(pPicScroll, , , TS_DISABLED)
            Call mDrawCaption(eNormal, pPicScroll)
    
    
    ' Botn Habilitado ::: Enabled = True
    '----------------------------------------------------------------------------------------------------
       Case True
          
          ' Estado normal, MouseUp, y MouseOver
          '----------------------------------------------------------------------------------------------------
          Select Case lMouseEvent
              Case 0
                If mbFlagMouseOver Then
                   Call mDrawSkinScroll(pPicScroll, , , TS_NORMAL)
                   Call mDrawSkinScroll(pPicScroll, , , TS_HOT)
                   Call mDrawCaption(Abs(mbFlagMouseOver), pPicScroll)
                   
                Else
                   ' MouseOut
                   '----------------------------------------------------------------------------------------------------
                   Call mDrawSkinScroll(pPicScroll, , , TS_NORMAL)
                   ' dibujar el texto del botn
                   Call mDrawCaption(Abs(mbFlagMouseOver), pPicScroll)
                End If
          ' Estado MouseDown
           '----------------------------------------------------------------------------------------------------
              Case 2
                Call mDrawSkinScroll(pPicScroll, , , TS_PRESSED)
                Call mDrawCaption(down, pPicScroll)
          End Select
    End Select
End Sub


'----------------------------------------------------------------------------------------------------
' \\ Rutina que dibuja los diferentes estados del botn de scroll : Estado normal, MouseOver, MouseUp etc ...
'----------------------------------------------------------------------------------------------------
Private Sub mDrawSkinScroll( _
    pPicScroll As PictureBox, _
    Optional ByVal lPixelWidth As Long = 0, _
    Optional ByVal lPixelHeight As Long = 0, _
    Optional ButtonState As ButtonState = TS_NORMAL)
    
    ' Ancho y alto
    With pPicScroll
        lPixelWidth = .ScaleWidth
        lPixelHeight = .ScaleHeight
    End With
    
    Dim dc As Long
    Dim hDCMemory As Long
    Dim hBmp As Long
    Dim SampleLeft As Long
        
    dc = GetDC(0)
    hDCMemory = CreateCompatibleDC(0)
    hBmp = CreateCompatibleBitmap(dc, lPixelWidth, lPixelHeight)
    Call SelectObject(hDCMemory, hBmp)
    Call SetStretchBltMode(hDCMemory, 4)
        
    ' calcular la posicin X, del la imagen a dibujar
    ' A partir del pixel 0 hasta el 15 es el estado MouseOver -  Posicin 15 MouseDown. - Posicin 30 Ckeck - posicin 45 MouseOver para el Check - Posicin 60 Estado normal - Pixel 75 para el deshabilitado
    SampleLeft = (SkinBtnWidth * ButtonState)
        
    Call BitBlt(hDCMemory, 0, 0, SkinBtnBorderW, SkinBtnBorderH, hDCSkin, SampleLeft, 0, vbSrcCopy)
    Call BitBlt(hDCMemory, lPixelWidth - SkinBtnBorderW, 0, SkinBtnBorderW, SkinBtnBorderH, hDCSkin, SampleLeft + SkinBtnWidth - SkinBtnBorderW, 0, vbSrcCopy)
    Call StretchBlt(hDCMemory, SkinBtnBorderW, 0, lPixelWidth - SkinBtnBorderW * 2, SkinBtnBorderH, hDCSkin, SampleLeft + SkinBtnBorderW, 0, SkinBtnWidth - SkinBtnBorderW * 2, SkinBtnBorderH, vbSrcCopy)
    Call StretchBlt(hDCMemory, 0, SkinBtnBorderH, SkinBtnBorderW, lPixelHeight - SkinBtnBorderH * 2, hDCSkin, SampleLeft, SkinBtnBorderH, SkinBtnBorderW, SkinBtnHeight - SkinBtnBorderH * 2, vbSrcCopy)
    Call StretchBlt(hDCMemory, SkinBtnBorderW, SkinBtnBorderH, lPixelWidth - SkinBtnBorderW * 2, lPixelHeight - SkinBtnBorderH * 2, hDCSkin, SampleLeft + SkinBtnBorderW, SkinBtnBorderH, SkinBtnWidth - SkinBtnBorderW * 2, SkinBtnHeight - SkinBtnBorderH * 2, vbSrcCopy)
    Call StretchBlt(hDCMemory, lPixelWidth - SkinBtnBorderW, SkinBtnBorderH, SkinBtnBorderW, lPixelHeight - SkinBtnBorderH * 2, hDCSkin, SampleLeft + SkinBtnWidth - SkinBtnBorderW, SkinBtnBorderH, SkinBtnBorderW, SkinBtnHeight - SkinBtnBorderH * 2, vbSrcCopy)
    Call BitBlt(hDCMemory, 0, lPixelHeight - SkinBtnBorderH, SkinBtnBorderW, SkinBtnBorderH, hDCSkin, SampleLeft, SkinBtnHeight - SkinBtnBorderH, vbSrcCopy)
    Call StretchBlt(hDCMemory, SkinBtnBorderW, lPixelHeight - SkinBtnBorderH, lPixelWidth - SkinBtnBorderW * 2, SkinBtnBorderH, hDCSkin, SampleLeft + SkinBtnBorderW, SkinBtnHeight - SkinBtnBorderH, SkinBtnWidth - SkinBtnBorderW * 2, SkinBtnBorderH, vbSrcCopy)
    Call BitBlt(hDCMemory, lPixelWidth - SkinBtnBorderW, lPixelHeight - SkinBtnBorderH, SkinBtnBorderW, SkinBtnBorderH, hDCSkin, SampleLeft + SkinBtnWidth - SkinBtnBorderW, SkinBtnHeight - SkinBtnBorderH, vbSrcCopy)
        
    Call BitBlt(pPicScroll.hdc, 0, 0, lPixelWidth, lPixelHeight, hDCMemory, 0, 0, vbSrcCopy)
        
    ' Eliminar los DC temporales
    Call DeleteDC(dc)
    Call DeleteDC(hDCMemory)
    Call DeleteObject(hBmp)
    
End Sub



'----------------------------------------------------------------------------------------------------
' Rutina para dibujar el texto del botn de los Scroll
'----------------------------------------------------------------------------------------------------
Private Sub mDrawCaption(ByVal lMouseEvent As eMouseEvent, pPicScroll As PictureBox)
    
On Error GoTo error_handler
    
    ' Color del texto
    Dim lColor As Long
    
    ' Verificar el Enabled
    '----------------------------------------------------------------------------------------------------
    If mEnabled = False Then
       ' Color de fuente botn deshabilitado
       lColor = mForeColorDisabled
    Else
       Select Case lMouseEvent
          ' normal
          Case 0
            lColor = mForeColorNormal
          ' MoueUp
          Case 1
            lColor = mForeColorUp
          ' MouseDown
          Case 2
             lColor = mForeColorDown
       End Select
    End If
               
    With pPicScroll
        .ForeColor = lColor
    End With
            
    
    ' Dibujar
    '----------------------------------------------------------------------------------------------------
    
    ' Calcular rea para dibujar el caption
    Dim x1 As Long
    Dim x2 As Long
    Dim y1 As Long
    Dim y2 As Long
    
    Dim sCaption As String
    
    ' Para saber que botn es ..
    If pPicScroll.Tag = 0 Then sCaption = "<"
    If pPicScroll.Tag = 1 Then sCaption = ">"
    
    ' Centrar
    With pPicScroll
         x1 = (.ScaleWidth - .TextWidth(sCaption)) / 2
        If lMouseEvent = down Then x1 = x1 + 1
        x2 = x1 + .TextWidth(sCaption)
        y1 = (.ScaleHeight - .TextHeight(sCaption)) / 2
        If lMouseEvent = down Then y1 = y1 + 1
        y2 = y1 + .TextHeight(sCaption)
    End With
    
    Dim r As RECT
    Call SetRect(r, x1, y1, x2, y2)  ' Copiar en r las coordenadas
    
    ' Dibujar el texto
    Call DrawText(pPicScroll.hdc, sCaption, Len(sCaption), r, DT_CENTER)
    
    ' refrescar control
    pPicScroll.Refresh
    
    
'\\ Errores
'----------------------------------------------------------------------------------------------------
Exit Sub
error_handler:
    If App.LogMode = 0 Then
       MsgBox Err.Description, vbCritical, "Error" & CStr(Err.Number)
    End If
End Sub


'\\ - Funcin para averiguar cuando se produce el mouseOver y MouseOut en el botn ( Mientras se est en MouseOver, se inicializa el Timer con 'id 0' para comprobar, y cuando se produce el mouseOut se detiene el Timer)
'----------------------------------------------------------------------------------------------------
Private Function mIsMouseOver() As Boolean
    Dim pt As POINTAPI
    
    ' Coordendas del mouse
    Call GetCursorPos(pt)
    
    ' Retornar el Hwnd del UC si se est en mouseOver, si no devuelve False
    mIsMouseOver = (WindowFromPoint(pt.x, pt.Y) = mHwndPicScroll)
End Function


'\\ -  Cargar en el Array  las imgenes de Skin desde el archivo de recursos con el mtodo LoadResPicture
'----------------------------------------------------------------------------------------------------
Private Sub mLoadArrSkins(Optional lSkin As Long = -1)
    
    On Error Resume Next ' no desactivar !!!!
    
    Dim lIndex As Integer
    lIndex = UBound(mArrstdPicSkins)
    
    If lSkin = -1 Then
        ' Si se produce error es por que no se habia cargado ... entonces cargar los grficos
        If Err.Number Then
            'COUNT_SKIN_RES > Cantidad de imgenes en el archvo de recursos
            ReDim mArrstdPicSkins(COUNT_SKIN_RES)
            Dim i As Integer
            ' Cargar
            For i = 0 To UBound(mArrstdPicSkins)
                Set mArrstdPicSkins(i) = LoadResPicture(101 + i, 0)
            Next
        End If
    Else
        ' Eliminar array de imgenes
        Erase mArrstdPicSkins
    End If
    
    ' Limpiar errores
    On Error GoTo 0
    
End Sub


'----------------------------------------------------------------------------------------------------
' \\ - Funcin para calcular y retornar el ndice de la imagen de acuerdo a posicin del mouse
'----------------------------------------------------------------------------------------------------

Private Function mGetIndexThumbnail(ByVal x As Single) As Integer
    ' Calcular el ndice de imagen
    Dim lPosx As Single
    lPosx = Round(x / mThumbnailSize, 1)
    
    If InStr(CStr(lPosx), ",") Then
        lPosx = Left(CStr(lPosx), InStr(CStr(lPosx), ","))
        lPosx = lPosx + 1
        If lPosx > 0 And lPosx <= mColThumbnails.Count Then
            mGetIndexThumbnail = lPosx
        Else
            mGetIndexThumbnail = -1
        End If
    Else
        mGetIndexThumbnail = -1
    End If
End Function

'----------------------------------------------------------------------------------------------------
' \\ -  Eventos de teclas
'----------------------------------------------------------------------------------------------------

Private Sub picThumb_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub picThumb_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub picThumb_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub


'----------------------------------------------------------------------------------------------------
' \\ -  MouseMove para los Thumbnails
'----------------------------------------------------------------------------------------------------

Private Sub picThumb_MouseMove(Button As Integer, Shift As Integer, x As Single, Y As Single)
    RaiseEvent ThumbnailMouseMove(mGetIndexThumbnail(x), Button, Shift, x, Y)
End Sub


'----------------------------------------------------------------------------------------------------
' \\ -  MouseDown de picBox para los Thumbnails ( para dibujar el rectngulo de seleccin )
'----------------------------------------------------------------------------------------------------
Private Sub picThumb_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)

On Error GoTo error_handler
    
    Dim lInitX As Long
    
    ' si el hacer clic, el control est deshabilitado o no hay imgenes, entonces salir
    If (picScrolls(0).Enabled = False) Or _
       (picScrolls(1).Enabled = False) Or _
       (mColThumbnails.Count = 0) Then
       
       Exit Sub
       
    End If
        
    ' Obtener ndice de la imagen
    Dim lIndex As Integer
    lIndex = mGetIndexThumbnail(x)
    
    ' Comprobar el ndice de imagen
    If (lIndex > 0) And (lIndex <= mColThumbnails.Count) Then
        
        ' Si se volvi a hacer clic en la misma imagen , salir ...
        If lIndex = mSelectedIndex Then
            RaiseEvent ThumbnailMouseDown(mSelectedIndex, Button, Shift, (x - lInitX) - (mThumbnailMargin / 2), Y)
            Exit Sub
        End If
        
         '... si no, guardar en mDirScrollSel, el sentido del scroll ( se usa desde el Timer con id 1 )
        If lIndex < mSelectedIndex Then mDirScrollSel = 0
        If lIndex > mSelectedIndex Then mDirScrollSel = 1
        
        ' Guardar imagen seleccionada actualmente
        mSelectedIndex = lIndex
        
        ' InitX es el X1 para dibujar el rectngulo de seleccin
        
        lInitX = (((mSelectedIndex - 1) * mThumbnailSize) + (mThumbnailMargin / 2))
        
        ' Comprobar el modo de Scroll para dibujar el rectngulo de seleccin
        If mScrollMode = eThumbs Then
            ' Para el timer por si ya estaba haciendo el scroll y se vuelve a hacer clic
            mTimer.TmrStop
            ' deshabilir los botones de scroll hasta que finalice ( se vuelve a resetear desde el timer )
            picScrolls(0).Enabled = False
            picScrolls(1).Enabled = False
            ' Calcula el centro del UC
            mPosCenter = ((picContainer.ScaleWidth - mThumbnailSize - (mThumbnailMargin / 2)) / 2)
            
            ' Limpiar el rectngulo de seleccin anterior
            picThumb.Cls
            
            ' Iniciar el Timer
            mOptionScroll = 1
            Call mTimer.TmrStart(Me, 1, 1)
            
        Else
           ' Modo sin scroll. Solo dibujar el rectngulo
           Call mDrawSelectedThumb(lInitX, 0, CLng(mThumbnailSize), CLng(mThumbnailSize))
           RaiseEvent ThumbnailClick(mSelectedIndex, mColThumbnails(mSelectedIndex))
        End If

        RaiseEvent ThumbnailMouseDown(mSelectedIndex, Button, Shift, (x - lInitX) - (mThumbnailMargin / 2), Y)
    End If
    
Exit Sub


'\\ Errores
'----------------------------------------------------------------------------------------------------
error_handler:
    If App.LogMode = 0 Then
       MsgBox Err.Description, vbCritical, "Error" & CStr(Err.Number)
    Else
       Err.Raise Err.Number, App.EXEName, Err.Description
    End If
    
End Sub



'----------------------------------------------------------------------------------------------------
'\\ Funcin para seleccionar la imagen
'----------------------------------------------------------------------------------------------------

Private Sub mSelectedThumb(Index As Integer, Optional RaiseEventClick As Boolean = True)
    
    On Error GoTo error_handler
            
    ' Comprobar que el ndice es vlido
    If Index > 0 And (Index <= mColThumbnails.Count) Then
        With picThumb
            ' Imagen actual
            mSelectedIndex = Index
            
            ' Dependiendo del modo de scroll, establecer el Left del picbox con los thumbnails
            If mScrollMode = eThumbs Then
                Dim lPosCenter As Long
                ' centrar
                lPosCenter = ((picContainer.ScaleWidth - mThumbnailSize - (mThumbnailMargin / 2)) / 2)
                .Left = lPosCenter - ((mSelectedIndex - 1) * mThumbnailSize)
            Else
                ' a la izquierda
                .Left = mScrollWidth
            End If
        End With
        ' Dibujar el rectngulo de seleccin
        Call mDrawSelectedThumb(((mSelectedIndex - 1) * mThumbnailSize) + (mThumbnailMargin / 2), 0, CLng(mThumbnailSize), CLng(mThumbnailSize))
        
        ' Enviar el evento ( el ndice de la imagen, la imagen)
        If RaiseEventClick Then RaiseEvent ThumbnailClick(mSelectedIndex, mColThumbnails(mSelectedIndex))
    End If
    
'\\ Errores
'----------------------------------------------------------------------------------------------------
    
    Exit Sub
error_handler:
    If App.LogMode = 0 Then
       If Err.Number = 5 Then
          MsgBox "No se ha encontrado el elemento"
       Else
          MsgBox Err.Description, vbCritical
       End If
    Else
       If Err.Number = 5 Then
          Err.Raise 5, App.EXEName, "No se ha encontrado el elemento indicado en la coleccin"
       Else
          Err.Raise Err.Number, App.EXEName, Err.Description
       End If
    End If
End Sub


'----------------------------------------------------------------------------------------------------
'\\ MouseMove para los botones de Scroll
'----------------------------------------------------------------------------------------------------

Private Sub picScrolls_MouseMove(Index As Integer, Button As Integer, Shift As Integer, x As Single, Y As Single)
    
    On Error GoTo error_handler
    
    mHwndPicScroll = picScrolls(Index).hwnd
    
    RaiseEvent ScrollMouseMove(Index, Button, Shift, x, Y)
    
    If Button < 2 Then
       If Not mIsMouseOver Then
          ' Esta lnea  se ejecuta  Cuando se presiona el boton y sin soltarlo se saca el puntero del mouse fuera del botn
          Call mUpdateBtn(eNormal, picScrolls(Index))
       Else
          If Button = 0 And Not mbFlagMouseOver Then
             ' Este bloque  se ejecuta  cuando se entra al botn, y se activa el timer para saber cuando se produce el MouseOut
             Call mTimer.TmrStart(Me, 50, 0)
             mbFlagMouseOver = True
             Call mUpdateBtn(eNormal, picScrolls(Index))
             mIndexScrollOver = Index
             RaiseEvent ScrollMouseOver(Index)
          ElseIf Button = 1 Then
             mbFlagMouseOver = True
             Call mUpdateBtn(down, picScrolls(Index))
             mbFlagMouseOver = False
          End If
       End If
    End If


'\\ Errores
'----------------------------------------------------------------------------------------------------
Exit Sub
error_handler:
    If App.LogMode = 0 Then
       MsgBox Err.Description, vbCritical, "Error: " & CStr(Err.Number)
    Else
       Err.Raise Err.Number, App.EXEName, Err.Description
    End If
End Sub


'----------------------------------------------------------------------------------------------------
'\\ Evento Clic para los botones de Scroll
'----------------------------------------------------------------------------------------------------

Private Sub picScrolls_Click(Index As Integer)
    If (mLastButton = 1 And mEnabled) Then
       Call mUpdateBtn(eNormal, picScrolls(Index))
       RaiseEvent ScrollClick(Index)
    End If
End Sub

'----------------------------------------------------------------------------------------------------
'\\ MouseDown para los botones de Scrolls
'----------------------------------------------------------------------------------------------------

Private Sub picScrolls_MouseDown(Index As Integer, Button As Integer, Shift As Integer, x As Single, Y As Single)

On Error GoTo error_handler
    
    ' Enviar el evento
    RaiseEvent ScrollMouseDown(Index, Button, Shift, x, Y)
    
    mLastButton = Button
    
    If Button <> 2 Then Call mUpdateBtn(down, picScrolls(Index))
    
    'Scroll centrado
    '--------------------------------------------------------------------------------
    If mScrollMode = eNormalScroll Then
        
        mCurrentDirScroll = Index
        mOptionScroll = 0
        Call mTimer.TmrStop
        Call mTimer.TmrStart(Me, 1, 1)
    
    'Scroll continuo
    '--------------------------------------------------------------------------------
    Else
       With picThumb
            Select Case Index
                ' Botn izquierdo ( Disminuir el selectedItem y dibujar la seleccin )
                Case 0
                    If mSelectedIndex > 1 Then
                        mSelectedIndex = mSelectedIndex - 1
                        Call mSelectedThumb(mSelectedIndex, True)
                    End If
                ' Botn Derecho ( Aumentar el selectedItem y dibujar la seleccin )
                Case 1
                    If mSelectedIndex < (mColThumbnails.Count) Then
                        mSelectedIndex = mSelectedIndex + 1
                        Call mSelectedThumb(mSelectedIndex, True)
                    End If
            End Select
        End With
    End If
    
' \\ Errores
'--------------------------------------------------------------------------------
Exit Sub
error_handler:
    If App.LogMode = 0 Then MsgBox Err.Description, vbCritical, "Error" & CStr(Err.Number)
End Sub


'----------------------------------------------------------------------------------------------------
'\\ - Sub para dibujar el rectngulo de seleccin
'----------------------------------------------------------------------------------------------------
Private Sub mDrawSelectedThumb(x1 As Long, y1 As Long, x2 As Long, y2 As Long)
    With picThumb
        .Cls
        If .DrawStyle <> 0 Then .DrawWidth = 1
        picThumb.Line (x1, y1 + 2)-Step(x2 - 1, y2 - 5), .ForeColor, B
        .Refresh
    End With
End Sub


'----------------------------------------------------------------------------------------------------
'\\ - Funcin que se usa desde el Timer para el Scroll centrado ( Cuando se termina, dibujar seleccin, establecer posicin izquierda del picThumb  y terminar el timer  )
'----------------------------------------------------------------------------------------------------

Private Sub mFinishScroll()
    ' detener Timer
    mTimer.TmrStop
    ' posicin del picBox ( centrar )
    picThumb.Left = mPosCenter - ((mSelectedIndex - 1) * mThumbnailSize)
    
    ' Rectngulo de seleccin
    Call mDrawSelectedThumb(((mSelectedIndex - 1) * mThumbnailSize) + (mThumbnailMargin / 2), 0, CLng(mThumbnailSize), CLng(mThumbnailSize))
    
    ' Volver a habilitar los btns de Scrolls
    picScrolls(0).Enabled = True
    picScrolls(1).Enabled = True
    
    ' Enviar evento clic para el thumbnail
    RaiseEvent ThumbnailClick(mSelectedIndex, mColThumbnails(mSelectedIndex))
End Sub


'----------------------------------------------------------------------------------------------------
'===============================================================================================================
' Fin de Funciones y Subs Privadas
'===============================================================================================================
'----------------------------------------------------------------------------------------------------

'----------------------------------------------------------------------------------------------------
' //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
'----------------------------------------------------------------------------------------------------



'----------------------------------------------------------------------------------------------------
'===============================================================================================================
' Eventos UC
'===============================================================================================================
'----------------------------------------------------------------------------------------------------


' Evento del control de usuario cuando cambian propiedades varias del entorno ( para actualizar el BackColor cuando se usa mUseBackColorContainer = true , y para el skin de tipo Link)
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Private Sub UserControl_AmbientChanged(PropertyName As String)
On Error GoTo error_handler

    If LCase(PropertyName) = "backcolor" Then
       'Dim lBkColor As Long
       'lBkColor = Extender.Container.BackColor
       'UserControl.BackColor = lBkColor
       'picContainer.BackColor = lBkColor
       'picThumb.BackColor = lBkColor
       'Me.ShowThumbnails
    End If
    
Exit Sub
error_handler:
    If App.LogMode = 0 Then
       MsgBox Err.Description, vbCritical, "Error: " & CStr(Err.Number)
    Else
       Err.Raise Err.Number, App.EXEName, Err.Description
    End If
    
End Sub


'----------------------------------------------------------------------------------------------------
' \\ Inicio del UC
'----------------------------------------------------------------------------------------------------
Private Sub UserControl_Initialize()
    
    ' Crear nueva coleccin para las imgenes
    If mColThumbnails Is Nothing Then
        Set mColThumbnails = New Collection
    End If
    ' Crear instancia del Timer
    If mTimer Is Nothing Then
        Set mTimer = New cTimer
    End If
    
    ' Cargar  imgenes de Skin desde el archivo de recursos
    Call mLoadArrSkins
    
    ' Inicializar array con los datos del texto con formato
    ReDim arrObjects(0)
    
    mSelectedIndex = -1
End Sub


'----------------------------------------------------------------------------------------------------
' \\ Fin del UC - destruir objectos
'----------------------------------------------------------------------------------------------------

Private Sub UserControl_Terminate()
    Call DeleteDC(hDCSkin)
    Call mLoadArrSkins(0)
    Set mSkinCustomPicture = Nothing
    Set mColThumbnails = Nothing
    Set mTimer = Nothing
End Sub

'----------------------------------------------------------------------------------------------------
' \\ Escribir propiedades del control en el PropBag
'----------------------------------------------------------------------------------------------------

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    With PropBag
        Call .WriteProperty("BorderColorSel", mBorderColorSel, vbWhite)
        Call .WriteProperty("BackColor", mBackColor, vbBlack)
        Call .WriteProperty("BorderStyleSel", mBorderStyleSel, 0)
        Call .WriteProperty("ScrollMode", mScrollMode, 0)
        Call .WriteProperty("ScrollWidth", mScrollWidth, 24)
        Call .WriteProperty("ThumbnailContainerMargin", mThumbnailContainerMargin, 2)
        Call .WriteProperty("ThumbnailMargin", mThumbnailMargin, 4)
        Call .WriteProperty("ThumbnailSize", mThumbnailSize, 32)
        Call .WriteProperty("SmallChangeScroll", mSmallChangeScroll, 16)
        Call .WriteProperty("SkinCustomPicture", mSkinCustomPicture, Nothing)
        Call .WriteProperty("Skin", mSkin, 13)
        Call .WriteProperty("Enabled", mEnabled, True)
        Call .WriteProperty("ToolTipText", mToolTipText, "")
    End With
End Sub



'----------------------------------------------------------------------------------------------------
' \\ Leer las propiedades guardadas desde el PropBag
'----------------------------------------------------------------------------------------------------

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

On Error GoTo error_handler

    With PropBag
        ' Deshabilitar la funcin mUpdateBTN
        mFlagReadInitProp = True
        mBorderColorSel = .ReadProperty("BorderColorSel", vbWhite)
        BackColor = .ReadProperty("BackColor", vbBlack)
        mBorderStyleSel = .ReadProperty("BorderStyleSel", 0)
        picThumb.DrawStyle = mBorderStyleSel
        mScrollMode = .ReadProperty("ScrollMode", 0)
        mScrollWidth = .ReadProperty("ScrollWidth", 24)
        mThumbnailContainerMargin = .ReadProperty("ThumbnailContainerMargin", 2)
        mThumbnailMargin = .ReadProperty("ThumbnailMargin", 4)
        mSmallChangeScroll = .ReadProperty("SmallChangeScroll", 16)
        ThumbnailSize = .ReadProperty("ThumbnailSize", 32)
        mEnabled = .ReadProperty("Enabled", True)
        
        mForeColorNormal = .ReadProperty("ForeColorNormal", mDefForeColorNormal)
        mForeColorDown = .ReadProperty("ForeColorDown", mDefForeColorDown)
        mForeColorUp = .ReadProperty("ForeColorUp", mDefForeColorUp)
        mForeColorDisabled = .ReadProperty("ForeColorDisabled", mDefForeColorDisabled)
        mToolTipText = .ReadProperty("ToolTipText", "")
        Set SkinCustomPicture = .ReadProperty("SkinCustomPicture", Nothing)
        Skin = .ReadProperty("Skin", 13)
        
    End With
    
    UserControl.Enabled = mEnabled
    
    ' Caargar valor de colores de fuente de acuerdo al Skin
    Call mSetColorSchemas
    
    ' Setear Flag para que ahora si se produzca el mUpdateBtn
    mFlagReadInitProp = False
    
    ' Actualizar botones de Scroll
    Call mUpdateBtn(eNormal, picScrolls(0))
    Call mUpdateBtn(eNormal, picScrolls(1))
    
Exit Sub


'\\ Errores
'----------------------------------------------------------------------------------------------------
error_handler:
    If App.LogMode = 0 Then
       MsgBox Err.Description, vbCritical, "Error: " & CStr(Err.Number)
    Else
       Err.Raise Err.Number, App.EXEName, Err.Description
    End If
    
End Sub


'----------------------------------------------------------------------------------------------------
' \\ - Evento cuando se redimensiona el botn
'----------------------------------------------------------------------------------------------------
Private Sub UserControl_Resize()

    ' UC
    With UserControl
        If .ScaleWidth < (mThumbnailSize + (mScrollWidth * 2) + (mThumbnailContainerMargin * 15) + mThumbnailMargin) Then
            .Width = (mThumbnailSize + (mScrollWidth * 2) + mThumbnailMargin + (mThumbnailContainerMargin * 15)) * Screen.TwipsPerPixelX
        End If
        .Height = (mThumbnailSize * Screen.TwipsPerPixelY) + (6 * Screen.TwipsPerPixelY)
    End With
            
    ' Contenedor de los botones de scroll y del picbox de los thumbnails
    With picContainer
        .Width = UserControl.ScaleWidth - (mThumbnailContainerMargin * 15)
        .Height = UserControl.ScaleHeight - 6
        .Top = (UserControl.ScaleHeight - .Height) / 2
        .Left = (UserControl.ScaleWidth - .Width) / 2
    End With
    
    ' Botones de Scroll
    With picScrolls(0)
        .Move 0, 0, mScrollWidth, picContainer.ScaleHeight
    End With
    With picScrolls(1)
        .Move picContainer.ScaleWidth - mScrollWidth, 0, mScrollWidth, picContainer.ScaleHeight
    End With
    
    ' PicBox para el Thumbnail
    With picThumb
        .Top = 0
        .Height = picContainer.ScaleHeight
        .Left = mScrollWidth
         Dim lWidth As Long
         lWidth = (mColThumbnails.Count * mThumbnailSize) + mThumbnailSize + mThumbnailMargin
         If lWidth < (picContainer.ScaleWidth - (mScrollWidth * 2)) Then
            .Width = picContainer.ScaleWidth - (mScrollWidth * 2)
         Else
            .Width = lWidth
         End If
        .ZOrder 1
    End With
    
    Call mUpdateBtn(eNormal, picScrolls(0))
    Call mUpdateBtn(eNormal, picScrolls(1))
    
    ' Dibujar Skin para el fondo ( En el UC )
    Call DrawSkinControl
    
    RaiseEvent Resize
    
End Sub



'----------------------------------------------------------------------------------------------------
'\\ - Incio de  propiedades cuando se agrega el UC al formulario
'----------------------------------------------------------------------------------------------------
Private Sub UserControl_InitProperties()
       
   ' Deshabilitar actualizacin para el redibujado del botn de scroll
   mFlagReadInitProp = True
   
   BackColor = vbBlack
   BorderStyleSel = eSolid
   ScrollMode = eThumbs
   ThumbnailContainerMargin = 2
   ScrollWidth = 24
   ThumbnailSize = [32x32]
   ThumbnailMargin = 8
   SmallChangeScroll = 16
   
   mForeColorNormal = vbBlack
   mForeColorUp = vbBlue
   mForeColorDown = vbRed
   mForeColorDisabled = RGB(190, 190, 190)
   Enabled = True
   Call mLoadArrSkins
   Skin = GooglePicasa
   
   'Habilitar redibujado -  no cambiar esto de lugar, por que si no no dibuja actualiza el las propiedades
   mFlagReadInitProp = False
   
   Call mUpdateBtn(eNormal, picScrolls(0))
   Call mUpdateBtn(eNormal, picScrolls(1))
   
End Sub


'----------------------------------------------------------------------------------------------------
'\\ - Show
'----------------------------------------------------------------------------------------------------
Private Sub UserControl_Show()
    If Ambient.UserMode Then Call UserControl_Resize
End Sub


'----------------------------------------------------------------------------------------------------
'\\ - MouseUp para los botones de Scroll - Para finalizar el Timer
'----------------------------------------------------------------------------------------------------
Private Sub picscrolls_MouseUp(Index As Integer, Button As Integer, Shift As Integer, x As Single, Y As Single)
    If mScrollMode = eNormalScroll Then
       mTimer.TmrStop
    End If
    If Button <> 2 Then
        Call mUpdateBtn(eNormal, picScrolls(Index))
    End If
    RaiseEvent ScrollMouseUp(Index, Button, Shift, x, Y)
End Sub


'----------------------------------------------------------------------------------------------------
'===================================================================================================
' Fin de Eventos del User control
'===================================================================================================
'----------------------------------------------------------------------------------------------------

'----------------------------------------------------------------------------------------------------
'///////////////////////////////////////////////////////////////////////////////////////////////////
'----------------------------------------------------------------------------------------------------





'----------------------------------------------------------------------------------------------------
'===================================================================================================
' Propiedades
'===================================================================================================
'----------------------------------------------------------------------------------------------------


'----------------------------------------------------------------------------------------------------
'\\ Enabled
'----------------------------------------------------------------------------------------------------
Public Property Get Enabled() As Boolean
    Enabled = mEnabled
End Property

Public Property Let Enabled(ByVal newValue As Boolean)
    mEnabled = newValue
    UserControl.Enabled = mEnabled
    ' Setear colores ( bordes, fuente y colores de fondos )
    Call mSetColorSchemas
    ' Redibujar
    Call mUpdateBtn(eNormal, picScrolls(0))
    Call mUpdateBtn(eNormal, picScrolls(1))

    Call PropertyChanged("Enabled")
End Property

'----------------------------------------------------------------------------------------------------
'\\ Propiedad para los Skins
'----------------------------------------------------------------------------------------------------
Public Property Get Skin() As eSkin
    Skin = mSkin
End Property

Public Property Let Skin(ByVal newValue As eSkin)

On Error GoTo error_handler

    ' asignar nuevo skin
    mSkin = newValue
    If mSkin <> CustomSkin Then
        ' Pasar la imagen ( ya est cargada en el array .. pero por las dudas)
        Call mSelectSkin(mArrstdPicSkins(mSkin).Handle)
    ElseIf (mSkin = CustomSkin) And (Not mSkinCustomPicture Is Nothing) Then
        Call mSelectSkin(mSkinCustomPicture.Handle)
    End If
    
    ' Recuperar colores de fuente, backcolor y redibujar
    Call PropertyChanged("Skin")
    Call mSetColorSchemas
    Call mUpdateBtn(eNormal, picScrolls(0))
    Call mUpdateBtn(eNormal, picScrolls(1))
    
    Dim lColor As Long
    'lColor = Me.GetSkinsColors(Normal_Skin)
    'If lColor > 0 Then picThumb.BackColor = lColor: picThumb.Refresh
    
    ' Color del borde de la seleccin
    '----------------------------------------------------------------------------------------------------
    lColor = Me.GetSkinsColors(Down_Skin)
    Call DrawSkinControl
    If lColor > 0 Then
        picThumb.ForeColor = lColor
        If mSkin = WindowsMedia Then picThumb.ForeColor = vbWhite
        If mSkin = WMPCobre Then picThumb.ForeColor = vbRed
        If mSkin = WMPVerde Then picThumb.ForeColor = vbGreen
        
        If mColThumbnails.Count > 0 And mSelectedIndex > 0 Then
           ' dibujar rectngulo de seleccin
           Call SelectedThumnail(mSelectedIndex, False)
        End If
    End If
    '----------------------------------------------------------------------------------------------------
    
    
'\\ Errores
'----------------------------------------------------------------------------------------------------
Exit Property
error_handler:
    If App.LogMode = 0 Then
       MsgBox Err.Description, vbCritical, "Error en la propiedad Skin."
    Else
       Err.Raise Err.Number, "Propiedad Skin", Err.Description
    End If
    
End Property



'\\ ToolTipText
'----------------------------------------------------------------------------------------------------
Property Let ToolTipText(sValue As String)
    mToolTipText = sValue
    Call PropertyChanged("ToolTipText")
End Property

Property Get ToolTipText() As String
    ToolTipText = mToolTipText
    picContainer.ToolTipText = mToolTipText
    picThumb.ToolTipText = mToolTipText
    Call PropertyChanged("ToolTipText")
End Property


'----------------------------------------------------------------------------------------------------
'\\ Estilo del borde
'----------------------------------------------------------------------------------------------------
Property Get BorderStyleSel() As eBorderStyleSel
    BorderStyleSel = mBorderStyleSel
End Property

Property Let BorderStyleSel(lValue As eBorderStyleSel)
    On Error GoTo error_handler
    
    mBorderStyleSel = lValue
    picThumb.DrawStyle = mBorderStyleSel
    Call PropertyChanged("BorderStyleSel")
    
    If mColThumbnails.Count > 0 And mSelectedIndex > 0 Then
       ' Volver a redibujar el rectngulo de seleccin
       Call SelectedThumnail(mSelectedIndex, False)
    End If
    
    Exit Property
error_handler:
    If App.LogMode = 0 Then
       MsgBox Err.Description, vbCritical, "Error: " & CStr(Err.Number)
    Else
       Err.Raise Err.Number, App.EXEName, Err.Description
    End If
End Property


'----------------------------------------------------------------------------------------------------
'\\ Color de fondo del rea delos Thumbnails ( no conviene cambiarlo en tiempo de ejecucin por que hay que redibujar todo de nuevo )
'----------------------------------------------------------------------------------------------------

Property Get BackColor() As OLE_COLOR
    BackColor = mBackColor
End Property

Property Let BackColor(lValue As OLE_COLOR)
    mBackColor = lValue
    picContainer.BackColor = lValue
    picThumb.BackColor = lValue
    If Ambient.UserMode Then Me.ShowThumbnails
    Call PropertyChanged("BackColor")
End Property


'----------------------------------------------------------------------------------------------------
'\\ Color del borde del rectngulo de seleccin
'----------------------------------------------------------------------------------------------------

Property Get BorderColorSel() As OLE_COLOR
    BorderColorSel = mBorderColorSel
End Property

Property Let BorderColorSel(lValue As OLE_COLOR)
    mBorderColorSel = lValue
    picThumb.ForeColor = lValue
    If Ambient.UserMode Then Call Me.SelectedThumnail(mSelectedIndex, False)
    Call PropertyChanged("BorderColorSel")
End Property


'----------------------------------------------------------------------------------------------------
'\\ Handle del UC
'----------------------------------------------------------------------------------------------------
Public Property Get hwnd() As Long
    hwnd = UserControl.hwnd
End Property


'----------------------------------------------------------------------------------------------------
'\\ Propiedad para cargar un Skin propio, ya sea desde la ventana de propiedades o e tiempo de ejecucin desde el disco, archivo de recursos etc ..
'----------------------------------------------------------------------------------------------------
Property Get SkinCustomPicture() As Picture
    Set SkinCustomPicture = mSkinCustomPicture
End Property

Property Set SkinCustomPicture(ByVal stdPic As Picture)
On Error GoTo error_handler

    Set mSkinCustomPicture = stdPic
    
    If Not mSkinCustomPicture Is Nothing Then
        Me.bFlagNoUpdateBtn = True
        Me.bFlagNoUpdateBtn = False
        Skin = CustomSkin
    Else
        Call mSelectSkin(0)
    End If
    
    Call PropertyChanged("SkinCustomPicture")
    Call mSetColorSchemas
    Call mUpdateBtn(eNormal, picScrolls(0))
    Call mUpdateBtn(eNormal, picScrolls(1))
    
' - Errores
'----------------------------------------------------------------------------------------------------
Exit Property
error_handler:
    If App.LogMode = 0 Then
       MsgBox Err.Description, vbCritical, "Error: " & CStr(Err.Number)
    Else
       Err.Raise Err.Number, App.EXEName, Err.Description
    End If
    
End Property


'----------------------------------------------------------------------------------------------------
'\\ ( BackColor y color de borde) - Propiedades para usar en tiempo de ejecucin para asignarlos a otros controles ( BackColor del Form etc ..)
'----------------------------------------------------------------------------------------------------
Property Get BackColorSkinDefault() As Long
    BackColorSkinDefault = mBackColorSkinDefault
End Property

Property Get BorderColorSkinDefault() As Long
    BorderColorSkinDefault = mBorderColorSkinDefault
End Property

'----------------------------------------------------------------------------------------------------
'\\ Valor para el desplazamiento del Scroll ( Solo cuando ScrollMode est en eNormal )
'----------------------------------------------------------------------------------------------------
Property Get SmallChangeScroll() As Long
    SmallChangeScroll = mSmallChangeScroll
End Property

Property Let SmallChangeScroll(lValue As Long)
    If lValue <= 10 Then lValue = 10
    mSmallChangeScroll = lValue
    Call PropertyChanged("SmallChangeScroll")
End Property

'----------------------------------------------------------------------------------------------------
'\\ Valor para el tamao de los Thumbnails
'----------------------------------------------------------------------------------------------------
Property Get ThumbnailSize() As eThumbnailSize
    ThumbnailSize = mThumbnailSize
End Property

Property Let ThumbnailSize(lValue As eThumbnailSize)
    mThumbnailSize = lValue
    
    If Ambient.UserMode = False Then
       UserControl.Height = (lValue * Screen.TwipsPerPixelY) + (mThumbnailContainerMargin * Screen.TwipsPerPixelY)
    Else
       picContainer.Visible = False
       UserControl.Height = (lValue * Screen.TwipsPerPixelY) + (mThumbnailContainerMargin * Screen.TwipsPerPixelY)
        
       ' Establecer el grosor del borde para el rectngulo de seleccin de acuerdo al tamao del Thumbnail
       '----------------------------------------------------------------------------------------------------
       With picThumb
           If lValue <= [48x48] Then
               .DrawWidth = 1
               mValueScrollSel = 10
           ElseIf lValue > [48x48] And lValue <= [96x96] Then
               .DrawWidth = 3
               mValueScrollSel = 20
           ElseIf lValue > [96x96] And lValue <= [156x156] Then
               .DrawWidth = 4
               mValueScrollSel = 30
           Else
               .DrawWidth = 5
               mValueScrollSel = 30
           End If
           ' Volver a cargar todos los Thumbnails
           Call ShowThumbnails
           
           If mColThumbnails.Count > 0 Then
              If mScrollMode = eNormalScroll Then
                 .Left = mScrollWidth
              End If
           End If
       End With
       
    End If
    Call PropertyChanged("ThumbnailSize")
End Property


'----------------------------------------------------------------------------------------------------
'\\ Valor para el MArgen interior de las imgenes
'----------------------------------------------------------------------------------------------------

Property Get ThumbnailMargin() As Integer
    ThumbnailMargin = mThumbnailMargin
End Property

Property Let ThumbnailMargin(ivalue As Integer)
    
    If ivalue < 4 Then ivalue = 4
    ' Comprobar que el margen no sea mas grande que la imagen
    If ivalue >= (mThumbnailSize / 2) And mThumbnailSize <> 0 Then
       ivalue = (mThumbnailSize / 2)
    End If
    
    mThumbnailMargin = ivalue
    
    ' Volver a cargar todo de nuevo
    Call UserControl_Resize
    Call Me.ShowThumbnails
    Call PropertyChanged("ThumbnailMargin")
End Property


'----------------------------------------------------------------------------------------------------
'\\ Valor para el MArgen entre los botones de Scroll y el UC
'----------------------------------------------------------------------------------------------------

Property Get ThumbnailContainerMargin() As Integer
    ThumbnailContainerMargin = mThumbnailContainerMargin
End Property

Property Let ThumbnailContainerMargin(ivalue As Integer)
    
    ' Verificar que no sea mas grande el ancho+el ancho de los botones
    If ((UserControl.ScaleWidth) - (ivalue * 15)) > ((mScrollWidth * 2) + mThumbnailSize + (mThumbnailMargin * 2)) Then
       If ivalue < 1 Then ivalue = 1
    Else
        If Not Ambient.UserMode Then
           MsgBox "El valor ingresado no es vlido. Ingrese un valor mas chico, o agrande el ancho del UC, y luego vuelva a ingresar un nuevo valor", vbCritical
           Exit Property
        Else
           ivalue = ((UserControl.ScaleWidth) - ((mScrollWidth * 2) + mThumbnailSize + (mThumbnailMargin * 2))) / 15
           'ivalue = (((mScrollWidth * 2) + mThumbnailSize + (mThumbnailMargin * 2))) / 15
        End If
    End If
    mThumbnailContainerMargin = ivalue
    ' Volver a cargar todo de enuvo
    Call UserControl_Resize
    Call Me.ShowThumbnails
    Call PropertyChanged("ThumbnailContainerMargin")
    
End Property


'----------------------------------------------------------------------------------------------------
'\\ Valor para el Ancho de los botones de Scroll
'----------------------------------------------------------------------------------------------------

Property Get ScrollWidth() As Integer
    ScrollWidth = mScrollWidth
End Property

Property Let ScrollWidth(ivalue As Integer)
    ' Valor mnimo
    If ivalue < 24 Then
        ivalue = 24
    End If
    
    ' Comprobar que el ancho no sea superior al contenedor ( Ancho de Uc + Mrgenes )
    If (ivalue * 2) < (picContainer.ScaleWidth - (mThumbnailSize + mThumbnailMargin)) Then
        mScrollWidth = ivalue
        
        ' volver a cargar todo de enuvo
        Call UserControl_Resize
        Call Me.ShowThumbnails
        Call PropertyChanged("ScrollWidth")
    Else
        If Not Ambient.UserMode Then
           MsgBox "El valor ingresado no es vlido. Ingrese un valor mas chico", vbCritical
        End If
    End If
End Property


'----------------------------------------------------------------------------------------------------
'\\ Modo De Scroll - 0 eNormal = Continuo --- 1 eThumb, centrado
'----------------------------------------------------------------------------------------------------

Property Get ScrollMode() As eScrollMode
    ScrollMode = mScrollMode
End Property

Property Let ScrollMode(lValue As eScrollMode)
    mScrollMode = lValue
    If mColThumbnails.Count > 0 Then
       If lValue = eNormalScroll Then picThumb.Left = mScrollWidth
    End If
    Call PropertyChanged("ScrollMode")
End Property


Property Get FinishLoadThumbs() As Boolean
Attribute FinishLoadThumbs.VB_MemberFlags = "400"
    FinishLoadThumbs = mFinishLoadThumbs
End Property

Property Get SelectedIndex() As Integer
Attribute SelectedIndex.VB_MemberFlags = "400"
    SelectedIndex = mSelectedIndex
End Property

'----------------------------------------------------------------------------------------------------
'\\ Propiedad con el ndice de la imagen seleccionada actualmente
'----------------------------------------------------------------------------------------------------
Property Let SelectedIndex(ivalue As Integer)
    mSelectedIndex = ivalue
End Property

'----------------------------------------------------------------------------------------------------
'\\ Propiedad con la cantidad de Thumbnails
'----------------------------------------------------------------------------------------------------
Property Get ImageCount() As Long
    ImageCount = mColThumbnails.Count
End Property


'----------------------------------------------------------------------------------------------------
'===================================================================================================
' Fin de Propiedades
'===================================================================================================
'----------------------------------------------------------------------------------------------------

